> For the complete documentation index, see [llms.txt](https://docs.lilypad.tech/lilypad/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.lilypad.tech/lilypad/developer-resources/module-marketplace/create-lilypad-module/folder-structure.md).

# Folder Structure

The folder structure output from using \`create-lilypad-module\`

## Output

After creation, your project should look like this:

```
project_name
├── config
│   └── constants.py
├── scripts
│   ├── docker_build.py
│   ├── download_models.py
│   └── run_module.py
├── src
│   └── run_inference.py
├── .dockerignore
├── .env
├── .gitignore
├── Dockerfile
├── lilypad_module.json.tmpl
├── README.md
└── requirements.txt
```

For the module to run, **these files must exist with exact filenames**:

* `src/run_inference.py`
  * The `Dockerfile` `ENTRYPOINT`.
  * If you change this files name or location, you must also update the `ENTRYPOINT` in your `Dockerfile` and `lilypad_module.json.tmpl` file to match.
* `config/constants.py`
  * The configuration file that stores the `DOCKER_REPO`, `DOCKER_TAG`, `MODULE_REPO`, and `TARGET_COMMIT`.
  * If you change this files name or location, you must also update the `import` statements in `scripts/docker_build.py` and `scripts/run_module.py`.
* `Dockerfile`
  * Required to build your module into a Docker image, and push the image to Docker Hub where it can be accessed by Lilypad Network.
* `requirements.txt`
  * Used by the `Dockerfile` to install dependencies required by your module.
  * Technically, this file can be deleted or renamed, but this naming convention is highly recommended as an industry standard best practice.
* `lilypad_module.json.tmpl`
  * The Lilypad configuration file.

You can delete or rename the other files.

You may create subdirectories inside `src`. For faster builds and smaller Docker images, only files inside `src` are copied by Docker. You need to put any files required to run your module inside `src`, otherwise Docker won’t copy them.

You can create more top-level directories. They will not be included in the final Docker image so you can use them for things like documentation.

If you have Git installed and your project is not part of a larger repository, then a new repository will be initialized resulting in an additional top-level `.git` directory.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.lilypad.tech/lilypad/developer-resources/module-marketplace/create-lilypad-module/folder-structure.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
